#include "scene.h"
#include <iostream.h>
#include <fstream.h>
#include <float.h>
#include <string.h>
#include "FL/gl.h"

Scene *scene;

Scene::Scene() {

  fb = new FrameBuffer(20, 40, 640, 480);
  fb->label("SW rendering");
  ui = new GraphAppUI();
  ui->GraphAppW->position(800, 40);
  Show();
  Redraw();

}

void Scene::Show() {

  if (fb)
    fb->show();
  if (ui)
    ui->GraphAppW->show();

}


void Scene::Redraw() {

  if (fb) {
    Render();
    fb->redraw();
  }

}


void Scene::DBG() {

  if (fb) {
    fb->Clear(0xFFFFFFFF);
    float uf = 150.0f;
    float vf = 200.0f;
    int size = 53;
    fb->DrawPointSquare(uf, vf, size, 0xFF00FF00);
    fb->DrawPointDiagonalCross(uf, vf, size, 0xFF0000FF);
    float u1f = 170.4f;
    float v1f = 301.9f;
    fb->DrawSegment(uf, vf, u1f, v1f, 0xFFFF0000);
    unsigned int colors[2] = {0xFF00FF00, 0xFF0000FF};
    fb->MakeChecker(30, colors);
  }
  Redraw();

}

void Scene::Render() {


}

void Scene::MouseMove(int u, int v) {

  if (!fb)
    return;
  fb->DrawPointSquare(.5f+(float)u, .5f+(float)v, 5, 0xFF000000);
  Redraw();

}